| Pattern                                                                              | Category               | Tags                              |
| :---                                                                                 | :---                   | :---                              |
| [Abstract Document](abstract-document)                                               | Structural             | Extensibility                     |
| [Abstract Factory](abstract-factory)                                                 | Creational             | Gang of Four                      |
| [Active Object](active-object)                                                       | Concurrency            | Performance                       |
| [Acyclic Visitor](acyclic-visitor)                                                   | Behavioral             | Extensibility                     |
| [Adapter](adapter)                                                                   | Structural             | Gang of Four                      |
| [Aggregator Microservices](aggregator-microservices)                                 | Architectural          | Cloud distributed                 |
| [Ambassador](ambassador)                                                             | Structural             | Decoupling                        |
| [API Gateway](api-gateway)                                                           | Architectural          | Cloud distributed, Decoupling     |
| [Arrange/Act/Assert](arrange-act-assert)                                             | Idiom                  | Testing                           |
| [Async Method Invocation](async-method-invocation)                                   | Concurrency            | Reactive                          |
| [Balking](balking)                                                                   | Concurrency            | Decoupling                        |
| [Bridge](bridge)                                                                     | Structural             | Gang of Four                      |
| [Builder](builder)                                                                   | Creational             | Gang of Four                      |
| [Business Delegate](business-delegate)                                               | Structural             | Decoupling                        |
| [Bytecode](bytecode)                                                                 | Behavioral             | Game programming                  |
| [Caching](caching)                                                                   | Behavioral             | Performance                       |
| [Callback](callback)                                                                 | Idiom                  | Reactive                          |
| [Chain of Responsibility](chain-of-responsibility)                                   | Behavioral             | Gang of Four                      |
| [Circuit Breaker](circuit-breaker)                                                   | Behavioral             | Performance, Decoupling           |
| [Cloud Static Content Hosting](cloud-static-content-hosting)                         | Cloud                  | Cloud distributed                 |
| [Collection Pipeline](collection-pipeline)                                           | Functional             | Reactive                          |
| [Combinator](combinator)                                                             | Idiom                  | Reactive                          |
| [Command](command)                                                                   | Behavioral             | Gang of Four                      |
| [Commander](commander)                                                               | Concurrency            | Cloud distributed                 |
| [Composite](composite)                                                               | Structural             | Gang of Four                      |
| [Composite Entity](composite-entity)                                                 | Structural             | Enterprise Integration Pattern    |
| [Converter](converter)                                                               | Creational             | Decoupling                        |
| [Command Query Responsibility Segregation](command-query-responsibility-segregation) | Architectural          | Performance, Cloud distributed    |
| [Data Access Object](data-access-object)                                             | Architectural          | Data access                       |
| [Data Bus](data-bus)                                                                 | Architectural          | Decoupling                        |
| [Data Locality](data-locality)                                                       | Behavioral             | Performance, Game programming     |
| [Data Mapper](data-mapper)                                                           | Architectural          | Decoupling                        |
| [Data Transfer Object](data-transfer-object)                                         | Architectural          | Performance                       |
| [Decorator](decorator)                                                               | Structural             | Gang of Four, Extensibility       |
| [Delegation](delegation)                                                             | Structural             | Decoupling                        |
| [Dependency Injection](dependency-injection)                                         | Creational             | Decoupling                        |
| [Dirty Flag](dirty-flag)                                                             | Behavioral             | Performance, Game programming     |
| [Double Buffer](double-buffer)                                                       | Behavioral             | Performance, Game programming     |
| [Double Checked Locking](double-checked-locking)                                     | Idiom                  | Performance                       |
| [Double Dispatch](double-dispatch)                                                   | Idiom                  | Extensibility                     |
| [EIP Aggregator](eip-aggregator)                                                     | Integration            | Enterprise Integration Pattern    |
| [EIP Message Channel](eip-message-channel)                                           | Integration            | Enterprise Integration Pattern    |
| [EIP Publish and Subscribe](eip-publish-and-subscribe)                               | Integration            | Enterprise Integration Pattern    |
| [EIP Splitter](eip-splitter)                                                         | Integration            | Enterprise Integration Pattern    |
| [EIP Wire Tap](eip-wire-tap)                                                         | Integration            | Enterprise Integration Pattern    |
| [Event Aggregator](event-aggregator)                                                 | Structural             | Reactive                          |
| [Event Based Asynchronous](event-based-asynchronous)                                 | Concurrency            | Reactive                          |
| [Event Driven Architecture](event-driven-architecture)                               | Architectural          | Reactive                          |
| [Event Queue](event-queue)                                                           | Concurrency            | Game programming                  |
| [Event Sourcing](event-sourcing)                                                     | Architectural          | Performance                       |
| [Execute Around](execute-around)                                                     | Idiom                  | Extensibility                     |
| [Extension Objects](extension-objects)                                               | Behavioral             | Extensibility                     |
| [Facade](facade)                                                                     | Structural             | Gang of Four, Decoupling          |
| [Factory](factory)                                                                   | Creational             | Gang of Four                      |
| [Factory kit](factory-kit)                                                           | Creational             | Extensibility                     |
| [Factory Method](factory-method)                                                     | Creational             | Gang of Four, Extensibility       |
| [Fan-Out/Fan-In](fanout-fanin)                                                       | Integration            | Microservices                     |
| [Feature Toggle](feature-toggle)                                                     | Behavioral             | Extensibility                     |
| [Filterer](filterer)                                                                 | Functional             | Extensibility                     |
| [Fluent Interface](fluent-interface)                                                 | Functional             | Reactive                          |
| [Flux](flux)                                                                         | Structural             | Decoupling                        |
| [Flyweight](flyweight)                                                               | Structural             | Gang of Four, Performance         |
| [Front Controller](front-controller)                                                 | Structural             | Decoupling                        |
| [Game Loop](game-loop)                                                               | Behavioral             | Game programming                  |
| [Guarded Suspension](guarded-suspension)                                             | Concurrency            | Decoupling                        |
| [Half-Sync Half-Async](half-sync-half-async)                                         | Concurrency            | Performance                       |
| [Hexagonal](hexagonal)                                                               | Architectural          | Decoupling                        |
| [Intercepting Filter](intercepting-filter)                                           | Behavioral             | Decoupling                        |
| Interpreter|Behavioral|Gang of Four |
| Iterator|Behavioral|Gang of Four |
| Layers|Architectural|Decoupling |
| Lazy Loading|Idiom|Performance |
| Leader Election|Behavioral|Cloud distributed |
| Leader Followers|Concurrency|Performance |
| Lockable Object|Concurrency|Performance |
| Marker Interface|Structural|Decoupling |
| Master Worker|Concurrency|Performance |
| Mediator|Behavioral|Gang of Four, Decoupling |
| Memento|Behavioral|Gang of Four |
| Model View Controller|Architectural|Decoupling |
| Model View Presenter|Architectural|Decoupling |
| Model View ViewModel|Architectural|Decoupling |
| Module|Structural|Decoupling |
| Monad|Functional|Reactive |
| Monostate|Creational|Instantiation |
| Multiton|Creational|Instantiation |
| Mute Idiom|Idiom|Decoupling |
| Naked Objects|Architectural|Decoupling |
| Null Object|Behavioral|Extensibility |
| Object Mother|Creational|Instantiation |
| Object Pool|Creational|Performance, Game programming |
| Observer|Behavioral|Gang of Four, Reactive |
| Page Object|Structural|Decoupling |
| Parameter Object|Behavioral|Extensibility |
| Partial Response|Behavioral|Decoupling |
| Pipeline|Behavioral|Decoupling |
| Poison Pill|Behavioral|Cloud distributed, Reactive |
| Presentation Model|Behavioral|Decoupling |
| Priority Queue|Behavioral|Decoupling |
| Private Class Data|Idiom|Data access |
| Producer Consumer|Concurrency|Reactive |
| Promise|Concurrency|Reactive |
| Property|Creational|Instantiation |
| Prototype|Creational|Gang of Four, Instantiation |
| Proxy|Structural|Gang of Four, Decoupling |
| Queue Based Load Leveling|Concurrency|Performance, Decoupling |
| Reactor|Concurrency|Performance, Reactive |
| Reader Writer Lock|Concurrency|Performance |
| Registry|Creational|Instantiation |
| Repository|Architectural|Data access |
| Resource Acquisition Is Initialization|Idiom|Data access |
| Retry|Behavioral|Performance |
| Role Object|Structural|Extensibility |
| Saga|Concurrency|Cloud distributed |
| Semaphore|Concurrency|Performance |
| Separated Interface|Structural|Decoupling |
| Servant|Behavioral|Decoupling |
| Serverless|Architectural|Cloud distributed |
| Service Layer|Architectural|Data access |
| Service Locator|Architectural|Performance, Game programming |
| Sharding|Behavioral|Performance, Cloud distributed |
| Singleton|Creational|Gang of Four |
| Spatial Partitiion|Behavioral|Performance, Game programming |
| Special Case|Behavioral|Extensibility |
| Specification|Behavioral|Data access |
| State|Behavioral|Gang of Four |
| Step Builder|Creational|Instantiation |
| Strangler|Structural|Cloud distributed, Extensibility |
| Strategy|Behavioral|Gang of Four |
| Subclass Sandbox|Behavioral|Game programming |
| Table Module|Structural|Data access |
| Template Method|Behavioral|Gang of Four |
| Thread Pool|Concurrency|Performance |
| Throttling|Behavioral|Performance |
| Thread Local Storage|Idiom|Performance |
| Tolerant Reader|Integration|Decoupling |
| Trampoline|Behavioral|Performance |
| Transaction Script|Behavioral|Data access |
| Twin|Structural|Extensibility |
| Type Object|Behavioral|Game programming, Extensibility |
| Unit of Work|Architectural|Data access |
| Update Method|Behavioral|Game programming |
| Value Object|Creational|Instantiation |
| Version Number|Concurrency|Data access, Microservices |
| Visitor|Behavioral|Gang of Four |
